#pragma once

#include <opencv2/core/mat.hpp>

struct MiddEvalCalib {
	float f;
	float cx;
	float cy;
	float baseline;
	float doffs;
	int width;
	int height;
	int ndisp;
	int vmin;
	int vmax;
};

MiddEvalCalib read_calibration(const std::string &filename);

cv::Mat read_pfm(const std::string &filename);

struct MiddleburyData {
	const std::string name;
	const cv::Mat imL;
	const cv::Mat imR;
	const cv::Mat gtL;
	const cv::Mat maskL;
	const MiddEvalCalib calib;
};

/** Load one middlebury dataset image
 * @param path path to image directory
 */
MiddleburyData load_input(const std::string &path);
