#pragma once
#ifndef _FTL_RGBD_MIDDLEBURY_SOURCE_HPP_
#define _FTL_RGBD_MIDDLEBURY_SOURCE_HPP_

//#include <loguru.hpp>

#include "../../basesource.hpp"
#include <ftl/cuda_common.hpp>
//#include <ftl/rgbd/camera.hpp>

namespace ftl {
namespace rgbd {
namespace detail {

class MiddleburySource : public BaseSourceImpl {
	public:
	explicit MiddleburySource(ftl::rgbd::Source *);
	MiddleburySource(ftl::rgbd::Source *, const std::string &dir);
	~MiddleburySource() {};

	bool capture(int64_t ts);
	bool retrieve(ftl::rgbd::Frame &);
	bool isReady() { return ready_; }

    static bool supported();

	private:
	bool ready_;

	cv::cuda::Stream stream_;

	cv::cuda::GpuMat left_;
	cv::cuda::GpuMat right_;
    cv::cuda::GpuMat gt_;
	cv::Mat mask_l_;
    ftl::rgbd::Camera params_;
    bool do_update_params_ = false;
};

}
}
}

#endif  // _FTL_RGBD_MIDDLEBURY_SOURCE_HPP_
